<template>
  <div class="setup">
    <!-- Resource Type Dropdown -->
    <div v-if="resourceTypes && resourceTypes.length > 0">
      <CoscineFormGroup
        :mandatory="true"
        label-for="ResourceTypes"
        :label="$t('page.createResource.configuration.labels.resourceType')"
        :is-loading="isLoading"
        info
      >
        <!-- Info Popover -->
        <template #popover>
          {{
            $t("page.createResource.configuration.labels.resourceTypePopover")
          }}
          <b-link
            :href="
              $t(
                'page.createResource.configuration.labels.resourceTypePopoverUrl',
              ).toString()
            "
            target="_blank"
          >
            {{ $t("default.help") }}
          </b-link>
        </template>

        <multiselect
          v-if="resourceTypes.length > 1"
          id="ResourceTypes"
          v-model="selectedResourceTypeInformation"
          :options="resourceTypes"
          :multiple="false"
          :hide-selected="false"
          label="iDisplayName"
          track-by="iDisplayName"
          :show-labels="false"
          :placeholder="
            $t('page.createResource.multiselect.placeholderResourceText')
          "
          select-label=""
          selected-label=""
          deselect-label=""
          :class="{
            invalid: v$.resourceForCreation.resourceTypeId.$dirty
              ? v$.resourceForCreation.resourceTypeId.$invalid
              : false,
          }"
          @update:modelValue="setSelectedResourceTypeInformation"
        >
          <template #noResult>
            {{ $t("page.createResource.multiselect.noResults") }}
          </template>
          <template #noOptions>
            {{ $t("page.createResource.multiselect.noOptions") }}
          </template>
        </multiselect>

        <!-- Resource Text Field (see condition) -->
        <b-form-input
          v-else-if="
            resourceTypes.length === 1 && selectedResourceTypeInformation
          "
          id="ResourceType"
          v-model="selectedResourceTypeInformation.iDisplayName"
          disabled
        />

        <!-- Hint -->
        <template #hint>
          <!-- Logged in with ORCID -->
          <i18n-t
            v-if="externalUser"
            scope="global"
            keypath="page.createResource.configuration.labels.hintTextORCiD"
            tag="span"
          >
            <template #userProfile>
              <b-link :to="{ name: 'userprofile' }">
                {{ $t("breadcrumbs.user.profile") }}
              </b-link>
            </template>
          </i18n-t>
          <!-- Logged in with SSO -->
          <span v-else>
            {{
              $t("page.createResource.configuration.labels.hintTextSSO", {
                organizationName: organizations.join(", "),
              })
            }}
          </span>
        </template>
      </CoscineFormGroup>

      <!-- Resource Description -->
      <CoscineFormGroup
        v-if="selectedResourceTypeInformation"
        :label="`${$t(
          'resourceTypes.' +
            selectedResourceTypeInformation.specificType +
            '.fullName',
        )}:`"
      >
        <p>
          {{
            $t(
              "resourceTypes." +
                selectedResourceTypeInformation.specificType +
                ".description",
            )
          }}
        </p>
      </CoscineFormGroup>
    </div>

    <!-- Setup Slider -->
    <ConfigurationSizeSlider
      v-if="selectedResourceTypeInformation?.isQuotaAvailable"
      v-model="resourceForCreation"
      :selected-resource-type-information="selectedResourceTypeInformation"
    />

    <GitLab
      v-if="
        selectedResourceTypeInformation &&
        selectedResourceTypeInformation.generalType ===
          coscineResourceTypes.Gitlab.General
      "
      v-model="resourceForCreation"
    />

    <!--Disclaimer for applicationProfile-->
    <CoscineFormGroup
      :label="$t('page.createResource.configuration.labels.disclaimerAP')"
    >
      <p>
        {{ $t("page.createResource.configuration.disclaimerAPText1") }}
        <b-link @click="toAIMS">{{
          $t("page.createResource.configuration.disclaimerAPAimsUrl")
        }}</b-link>
        <br />
        {{ $t("page.createResource.configuration.disclaimerAPText2") }}
        <b-link
          :href="
            $t(
              'page.createResource.configuration.disclaimerAPHelpUrl',
            ).toString()
          "
          target="_blank"
        >
          {{ $t("page.createResource.configuration.disclaimerAPHelpUrl") }}
        </b-link>
      </p>
    </CoscineFormGroup>

    <!-- Button Next (wrapper needed for Popover) -->
    <div id="divButtonNext" class="float-end">
      <b-button
        variant="outline-primary"
        :disabled="v$.resourceForCreation.$invalid"
        @click.prevent="next"
      >
        {{ $t("buttons.next") }}
      </b-button>
    </div>

    <!-- Popover -->
    <b-popover
      v-if="
        ((resourceForCreation.resourceTypeOptions?.rdsResourceTypeOptions?.quota
          ?.value &&
          resourceForCreation.resourceTypeOptions?.rdsResourceTypeOptions?.quota
            ?.value <= 0) ||
          (resourceForCreation.resourceTypeOptions?.rdsS3ResourceTypeOptions
            ?.quota?.value &&
            resourceForCreation.resourceTypeOptions?.rdsS3ResourceTypeOptions
              ?.quota?.value <= 0) ||
          (resourceForCreation.resourceTypeOptions?.rdsS3WormResourceTypeOptions
            ?.quota?.value &&
            resourceForCreation.resourceTypeOptions
              ?.rdsS3WormResourceTypeOptions?.quota?.value <= 0)) &&
        selectedResourceTypeInformation?.isQuotaAvailable
      "
      target="divButtonNext"
      :title="$t('page.createResource.configuration.popover.title')"
      placement="top"
      triggers="hover"
      :delay="{ show: 0, hide: 500 }"
    >
      {{ $t("page.createResource.configuration.popover.body") }}

      <!-- Router Link -->
      <router-link v-if="isOwner" :to="{ name: 'project-quota' }">
        {{ $t("page.createResource.configuration.needMore") }}
      </router-link>
    </b-popover>
  </div>
</template>

<script lang="ts" setup>
import useResourceStore from "../../store";
import useProjectStore from "@/modules/project/store";
import useLoginStore from "@/modules/login/store";
import useMainStore from "@/store/index";

import type { ExtendedResourceTypeInformationDto } from "../../types";
import { CoscineResourceTypes } from "../../types";
import useUserStore from "@/modules/user/store";
import type {
  ResourceForCreationDto,
  ResourceTypeInformationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import useVuelidate from "@vuelidate/core";
import { required } from "@vuelidate/validators";
import {
  ResourceTypeInformationDto2ResourceTypeOptionsForCreationDto,
  resourceMapper,
} from "@/mapping/resource";
import {
  onlyOneResourceTypeOptionSet,
  validResourceTypeOptions,
} from "../../utils/validators";

import ConfigurationSizeSlider from "./ConfigurationSizeSlider.vue";
import GitLab from "./resource-type/GitLab.vue";

import { useI18n } from "vue-i18n";
const i18n = useI18n();

const router = useRouter();

const resourceForCreation = defineModel<ResourceForCreationDto>({
  required: true,
});

defineProps({
  isLoading: {
    default: false,
    type: Boolean,
  },
});

const emit = defineEmits<{
  valid: [_: boolean];
  next: [];
}>();

const mainStore = useMainStore();
const loginStore = useLoginStore();
const projectStore = useProjectStore();
const resourceStore = useResourceStore();
const userStore = useUserStore();

/*
  Definition of the validation rules and initial state
  will enable proper typings in the code
*/
const state = reactive({
  resourceForCreation: resourceForCreation,
});
const rules = {
  resourceForCreation: {
    resourceTypeId: { required },
    resourceTypeOptions: {
      onlyOneResourceTypeOptionSet,
      validResourceTypeOptions,
    },
  },
};
const v$ = useVuelidate(rules, state);

const coscineResourceTypes = CoscineResourceTypes;
const selectedResourceTypeInformation = ref(
  null as ExtendedResourceTypeInformationDto | null,
);

const isOwner = computed(() => {
  return projectStore.currentUserRoleIsOwner;
});

const organizations = computed(() => {
  if (userOrganizations.value) {
    return userOrganizations.value
      .filter((organization) => !(organization.uri?.indexOf("#") !== -1)) // If does contain "#" it's a sub level organization, otherwise top level
      .map((org) => (org.displayName ? org.displayName : "")) // Extract organization display name, could contain empty strings
      .filter((n) => n); // Filter out empty strings, if any;
  }
  return [];
});
const externalUser = computed(() => {
  // Organizations with readOnly === true are coming from Shibboleth (internal)
  return !userOrganizations.value?.some((o) => o.readOnly);
});

const userOrganizations = computed(() => {
  return userStore.user?.organizations;
});
const resourceTypes = computed(() => {
  const labeledResourceTypes: ExtendedResourceTypeInformationDto[] = [];
  const resourceTypes = resourceStore.enabledResourceTypes;
  if (resourceTypes) {
    resourceTypes.forEach((r) => {
      const labeledResourceType: ExtendedResourceTypeInformationDto = {
        iDisplayName: i18n
          .t("resourceTypes." + r.specificType + ".displayName")
          .toString(),
      };
      Object.assign(labeledResourceType, r);
      labeledResourceTypes.push(labeledResourceType);
    });
    return labeledResourceTypes.sort((a, b) => {
      const valueA = a.iDisplayName.toUpperCase();
      const valueB = b.iDisplayName.toUpperCase();
      return valueA < valueB ? -1 : valueA > valueB ? 1 : 0;
    });
  } else {
    return null;
  }
});

watch(
  () => resourceForCreation.value.resourceTypeOptions,
  () => {
    v$.value.resourceForCreation.resourceTypeOptions.$validate();
  },
  { deep: true },
);
watch(
  () => resourceTypes.value,
  () => {
    onResourceTypesLoaded();
    initTabContent();
  },
);
watch(
  () => v$.value.resourceForCreation.$invalid,
  () => {
    emit("valid", !v$.value.resourceForCreation.$invalid);
  },
);

/**
 * Emits a "next" event to notify the parent component to proceed to the next step.
 */
const next = () => {
  emit("next");
};

/**
 * Initializes the content of the tab by setting the selected resource type information
 * and the selected application profile based on the current state of the resource for creation.
 */
const initTabContent = () => {
  if (resourceTypes.value) {
    // A resource type has been selected, but the dropdown is empty. Set selection in dropdown.
    const selection = resourceTypes.value.find(
      (r) => r.id === resourceForCreation.value.resourceTypeId,
    );
    if (selection) {
      selectedResourceTypeInformation.value = selection;
    }
  }
};

/**
 * Called when resource types are loaded.
 * If there is only one resource type, it sets the selected resource type information.
 */
const onResourceTypesLoaded = () => {
  if (resourceTypes.value && resourceTypes.value.length === 1) {
    setSelectedResourceTypeInformation(resourceTypes.value[0]);
  }
};

/**
 * Sets the selected resource type information.
 *
 * @param {ResourceTypeInformationDto | null} resourceTypeInformation - The information about the selected resource type.
 */
const setSelectedResourceTypeInformation = (
  resourceTypeInformation: ResourceTypeInformationDto | null,
) => {
  resourceForCreation.value.resourceTypeId = resourceTypeInformation?.id ?? "";
  v$.value.resourceForCreation.resourceTypeId.$touch();
  if (resourceTypeInformation) {
    resourceForCreation.value.resourceTypeOptions = resourceMapper.map(
      ResourceTypeInformationDto2ResourceTypeOptionsForCreationDto,
      resourceTypeInformation,
    );
  } else {
    resourceForCreation.value.resourceTypeOptions = {};
  }
  v$.value.resourceForCreation.resourceTypeOptions.$validate();
};

const toAIMS = async () => {
  const accessToken = loginStore.authorization.bearer;
  const url = router.resolve({
    path: "/coscine/apps/aimsfrontend/",
    query: { token: accessToken },
  }).href;
  window.open(url);
};

onResourceTypesLoaded();
initTabContent();

mainStore.$subscribe((mutation) => {
  if (mutation.type == "patch function") {
    initTabContent();
  }
});
</script>
